import Utils from "~/utils";
export default {
  methods: {
    // 校验公共表单
    // checkCommonForm () {
    //   return Promise((resolve, reject) => {
    //     return this.handleCommonFormValiate()
    //   })
    // },
    async checkCommonForm () {
      console.log(this.$refs)
      let tasks = []
      let self = this
      Object.keys(this.$refs).forEach(ref => {
        if (self.$refs[ref]) {
          Object.keys(self.$refs[ref].$refs).forEach(item => {
            if (item.indexOf('commonform_') !== -1) {
              console.log(self.$refs[ref].$refs[item])
              tasks.push(Utils.getFormPromise(self.$refs[ref].$refs[item].$refs['commonform']))
            }
          })
        }
      })
      if(tasks.length > 0) {
        let res = await Promise.all(tasks).then(res => {
          let flag = res.every(item => {
            return item
          })
          console.log(flag)
          if (flag) {
            return true
          } else {
            return false
          }
        }).catch(err => {
          return false
        })
        return res
      } else {
        return true
      }
    },
    scrollToCheckError () {
      //定位到报错的地方
      let errElems = document.getElementsByClassName('el-form-item__error')
      let id
      let declareId
      if (errElems && errElems[0]) {
        let target = errElems[0]
        while(target && target.parentElement) {
          if (target.parentElement.classList.contains('el-tab-pane')) {
            if (target.parentElement.id.indexOf('decl_') !== -1) {
              declareId = target.parentElement.id
              target = target.parentElement
            } else {
              id = target.parentElement.id
              break
            }
          } else {
            target = target.parentElement
          }
        }
      }
      if (id && id.split('-')[1]) {
        this.activeName = id.split('-')[1]
        if (declareId && this.activeName) {
          let declareActiveName = declareId.split('-')[1] || ''
          this.$refs[this.activeName].activeName = declareActiveName
        }
        this.$nextTick(() => {
          errElems[0].scrollIntoView(false)
        })
      }
    }
  }
}