import AmlCheckModel from "~/model/widget/Aml/AmlCheckModel"

export default {
  data () {
    return {
      amlCheckModel: new AmlCheckModel().data,
      amlTempData: this.$route.query.routeParams && this.$route.query.routeParams.amlTempData || undefined
    }
  },
  computed: {
    amlProps () {
      return {
        trigger: this.process == '0' || !this.isReview,//是否触发筛查，仅在受理中心经办触发筛查
        amlCheckModel: new AmlCheckModel().data, //反洗钱筛查模型
        txSriNo: this.serialNo
      }
    }
    
  },
  methods: {
    reSubmit() {
      this.amlCheckModel.flag = true;
      this.handleStart(); //再次调用原交易界面提交按钮
    },
    showAml() {
      this.aml()
      let params = {
        head: this.genRequestHead(),
        body: {
          amlCheckVo: this.amlCheckModel
        }
      }
      this.$refs.aml && this.$refs.aml.handleClick(this.amlProps.trigger, this.amlProps.txSriNo, params)
    },
  }
}